//                                                                                
//    Copyright (c) 2004/2005 Thomas Fuchs / The Rockin'-B, www.rockin-b.de       
//                                                                                
//    Permission is granted to anyone to use this software for any purpose        
//    and to redistribute it freely, subject to the following restrictions:       
//                                                                                
//    1.  The origin of this software must not be misrepresented. You must not    
//        claim that you wrote the original software. If you use this software    
//        in a product, an acknowledgment in the product documentation would be   
//        appreciated but is not required.                                        
//                                                                                
//    2.  ANY COMMERCIAL USE IS PROHIBITED. This includes that you must not use   
//        this software in the production of a commercial product. Only an explicit
//        permission by the author can allow you to do that.                      
//                                                                                
//    3.  Any modification applied to the software must be marked as such clearly.
//                                                                                
//    4.  This license may not be removed or altered from any distribution.       
//                                                                                
//                                                                                
//    			    NO WARRANTY                                                 
//                                                                                
//    THERE IS NO WARRANTY FOR THE PROGRAM.                                       
//    THE PROGRAM IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,               
//    EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO,                 
//    THE IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR PURPOSE.                 
//    THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.
//    SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY    
//    SERVICING, REPAIR OR CORRECTION.                                            
//                                                                                
//    IN NO EVENT WILL THE COPYRIGHT HOLDER BE LIABLE TO YOU FOR DAMAGES,         
//    INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING 
//    OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED   
//    TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY    
//    YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER  
//    PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE       
//    POSSIBILITY OF SUCH DAMAGES.                                                
//                                                                                


#ifdef __cplusplus
extern "C" {
#endif

#include <SGL.H>

#ifdef __cplusplus
}
#endif

//#include <stdio.h>
//#include <stdlib.h>
#include <string.h>
#include "src/system.h"
#include "portingHandy.h"
#include <RB_minCD.h>


// although ignored currently
char *romfile = "lynxboot.img";
char *gamefile = "blockout.lnx";

unsigned short screenbuf[160*102];
//screenbuf = (unsigned short*)MEM_Malloc(160*102*2);
CSystem * newsystem;

int frameskipcount, frameskip;
int frame;

void swapBytes(char *data, int size)
{
    int i, o;
    char c;
    for(i = 0; i < ((size + 2) >> 2); i++) {
        o = i << 2;
        c = *(data + o + 3);
        *(data + o + 3) = *(data + o + 0);
        *(data + o + 0) = c;

        c = *(data + o + 2);
        *(data + o + 2) = *(data + o + 1);
        *(data + o + 1) = c;
    }
}

void initializeVDP2FB(unsigned int options)
{
// the address for background color in VRAM is taken from various examples,
// don't know why
// !!! beware, 1st try the bgcol was the only thing to see on real Saturn
// what exactly is the back_col_adr? maybe the color at this adress is 
// interpreted as background color and wheereever such color occurs,
// it's replaced by the given one
// !! all i see is the background color....
    slBack1ColSet((void *)BACK_CRAM, CD_Black);
    
    
// the debug text lib take the NBG0 scroll <- the only one with 24bits color depth
// priority = 0 -> scroll not displayed
// take farest away    
    slPriorityNbg0(7);
    slPriorityNbg1(6);
//    slPrioritySpr0-7(0);    

// we want bitmap scrolls
// only NBG0 and NBG1 can handle bitmap mode
// color modes:
//      palettet:           COL_TYPE_16, COL_TYPE_256, COL_TYPE_2048
//      rgb:                COL_TYPE_32768, COL_TYPE_1M
// bitmap sizes(BM_HxV):    BM_512x256, BM_512x512, BM_1024x256, BM_1024x512
    slBitMapNbg1(COL_TYPE_32768, BM_512x256, (void *)VDP2_VRAM_A0);
    memset((void *)VDP2_VRAM_A0, CD_Black, 256*512*2);

// monitor position in scroll coordinate space
// sets the position of monitors topleft corner(fixed format)
// fix for Satourne
//    slScrPosNbg1(toFIXED(0.0), toFIXED(-17.0));
    slScrPosNbg1(toFIXED(0.0), toFIXED(0.0));

// reduction setting: only NGB0 and NBG1 are able to RBG, too)
// modes:   ZOOM_1, ZOOM_HALF, ZOOM_QUATER      each untill x256
    slZoomModeNbg1(ZOOM_1);
    
// zoom
// fixed point reziprocal of scale ratio in x and y direction
    slZoomNbg1(toFIXED(0.5), toFIXED(0.5));            

// registeres scrolls
// call only after all scroll function settings
// returns 0 or -1(ERROR)
    slScrAutoDisp(NBG0ON | NBG1ON);
}

void initializeDisplay(unsigned int options)
{
// caution: when setting to 2, strange errors occur in satourne
    slInitSystem(TV_320x240, (TEXTURE *)NULL, 1);
//    slInitSystem(TV_320x224, NULL, 2);
    
    slTVOff();

    initializeVDP2FB(options);
    
    slTVOn();
}

#if 0
C6502_REGS regs;
char str[41];
#include "src/DIS6502.H"

void printDebug()
{
    slPrint("debug info:", slLocate(5, 5));
        // cartridge name
    snprintf(str, 40, "running cart: %s", newsystem->CartGetName());
    slPrint(str, slLocate(5, 6));
        // cycle count
    snprintf(str, 40, "cycle: %x", gSystemCycleCount);
    slPrint(str, slLocate(5, 7));
        // register status
    newsystem->GetRegs(regs);
    snprintf(str, 40, "PS %x A %x SP %x", regs.PS, regs.A, regs.SP);
    slPrint(str, slLocate(5, 8));
    snprintf(str, 40, "PC %x NMI %i IRQ %i WAIT %i", regs.PC, regs.NMI, regs.IRQ, regs.WAIT);
    slPrint(str, slLocate(5, 9));
    snprintf(str, 40, "Opcode: %x = %s", regs.Opcode, mLookupTable[regs.Opcode].opcode);
    slPrint(str, slLocate(5, 10));
    snprintf(str, 40, "boot: %x, button: %x", gCPUBootAddress, newsystem->GetButtonData());
    slPrint(str, slLocate(5, 11));
    
}
#endif

static void *render()
{
//    static int frameskipcount=0, frameskip=0;
    Uint16 *VRAM, pix, *buf;
    int i, j;

#if 0    
    // frameskip adjustment
    if((Smpc_Peripheral[0].data & PER_DGT_TL) == 0) {
            if(frameskip > 0)
                frameskip--;
    }
    if((Smpc_Peripheral[0].data & PER_DGT_TR) == 0)
        frameskip++;
#endif
    
	// Skip frames if required
	EMST_frames(1);
	if(frameskipcount>0) {
		frameskipcount--;
	} else {
		// Reset the frameskip counter
		frameskipcount=frameskip;

        // there is only a single call to this function inside Handy source:
        // when Mickie sets CPU sleep..
        // so let's do it here
        if(sprites_enable == 1)        
            newsystem->PaintSprites();

        // some display
        EMST_display();
        slPrintHex(sprites_enable, slLocate(15, 26));
        slPrintHex(frameskip, slLocate(15, 27));
        slPrintHex(frame, slLocate(15, 28));

        // screen update
        VRAM = (Uint16 *)VDP2_VRAM_A0;
//        buf = (Uint16 *)ptr;
        for(i = 0; i < 102; i++) {
            for(j = 0; j < 160; j++) {
                pix = *(screenbuf + i*160 + j);
//                *(VRAM + i*512 + j) = CD_Blue | RGB_Flag;
//                *(VRAM + i*512 + j) = (j << 5) | i | RGB_Flag;
                *(VRAM + i*512 + j) =  ((pix & 0x1F) << 10) | ((pix & (0x1F << 5))) | ((pix & (0x1F << 10)) >> 10) | RGB_Flag;
            }
        }
// disabled for slave, he got the time..
        slSynch();
	}
    frame++;
    // if the next frame will be transfered to VRAM,
    // prepare Handy to draw it
    EMST_stop();
    if(frameskipcount == 0)
        return screenbuf;
    else return NULL;
}


UBYTE* DisplayCallback(ULONG objref)
{
    Uint16 data = Smpc_Peripheral[0].data;
//    static int frame=0;
    EMST_start(EMST_VRAM);
    // don't move this to main loop,
    // it would be processed far too often there!!!
    
    // frameskip adjustment
    if((frameskip > 0) && ((data & PER_DGT_TL) == 0))
        frameskip--;
    if((frameskip < 30) && ((data & PER_DGT_TR) == 0))
        frameskip++;
    // sprites_enable: press L+R+C to disable, L+R to enable
    if(((data & PER_DGT_TL) == 0) && ((data & PER_DGT_TR) == 0)) {
        if((data & PER_DGT_TC) == 0)
            sprites_enable = 0;
        else sprites_enable = 1;
    }    


#if 0
    // debug info:
    clearText();
    if((Smpc_Peripheral[0].data & PER_DGT_ST) == 0) 
        printDebug();
#endif

 
#if 0
    // even frames: first half of screenbuffer
    // odd frames: second
    if(frame & 1) {
        slSlaveFunc(render, screenbuf);
	   // Now return a pointer to the painting buffer for the next frame
        return (UBYTE *)screenbuf + 160*102*2;
    } else {
        slSlaveFunc(render, screenbuf + 160*102*2);
	   // Now return a pointer to the painting buffer for the next frame
        return (UBYTE *)screenbuf;
    }
#else
    return (UBYTE *)render();
    // Now return a pointer to the painting buffer for the next frame
//    return (UBYTE *)screenbuf;

#endif        
}

#if 0
void test_workRAMlow()
{
    char str[] = "This string is copied to low work RAM!"; 
    memcpy((void *)0x200000, str, sizeof(str) / sizeof(char));   

    slPrint("string original:", slLocate(5, 3));
    slPrint(str, slLocate(5, 4));
    slPrint("string copy in low work RAM:", slLocate(5, 6));
    *((char *)0x200000 + sizeof(str)) = '\0';
    slPrint((char *)0x200000, slLocate(5, 7));
    
    while(1) {
        slSynch();
    }    
}
#endif
  
static void ss_main(void)
{
    // configure MINCD_load
    // decreasing priority
        // for game roms
    FIO_ftype ftypes[] = {
        {"*.o", {0, 0x400000}, "Lynx homebrew rom", FIO_OP_LOAD},
        {"*.lnx", {0, 0x400000}, "Lynx commercial rom", FIO_OP_LOAD},
    };
    FIO_in in = {ftypes, sizeof(ftypes)/sizeof(FIO_ftype), (unsigned char *)NULL, 0};
        // for bios rom
    FIO_ftype ftypes2[] = {
        {"*.img", {0, ROM_SIZE}, "Lynx bios rom", FIO_OP_LOAD},
    };
    FIO_in in2 = {ftypes2, sizeof(ftypes2)/sizeof(FIO_ftype), (unsigned char *)romdata, ROM_SIZE};
    FIO_out out;
    Uint16 data;
    int i;

    initializeDisplay(0);
    
    EMST_init(4, 256, 3);
    EMST_name(EMST_CPU, "cpu");
    EMST_name(EMST_MICKIE, "mickie");
    EMST_name(EMST_VRAM, "vram");
    EMST_name(EMST_PAD, "pad");

//    MEM_Init(LOW_MEM_START, LOW_MEM_SIZE);
#ifndef PORTING_ROM_INCLUDED
    MINCD_init();
//    romdata = (char *)malloc(ROM_SIZE);
//    romdata_size = MINCD_load("Select bios rom:", ".img.IMG", romdata, ROM_SIZE);
    MINCD_load("Select a bios ROM:", &in2, &out);
    romdata_size = out.value.size;
#endif
//    slPrint("Rockin'-B's Lynx", slLocate(8, 3));
//    slSynch();
 
    // double buffer in low workRAM
    // we could possibly let it render to 
    // VDP2 VRAM directly
//    screenbuf = (unsigned short*)MEM_Malloc(160*102*2);
    
    // always stay in emu
    while(1) {
        // load the rom
        clearText();
#ifndef PORTING_ROM_INCLUDED
        gamedata = (char *)PORTING_CARTBANK0_ADR;
        in.dest = (unsigned char *)gamedata;
        in.destSize = 0x80000 + 0x100;
        // allow slightly bigger size than possible
        // Ninja2.LNX is somehow 0x40 bytes bigger
        do {
            MINCD_load("Select a ROM:", &in, &out);
        } while(out.value.size == 0);
        gamedata_size = out.value.size;
#else
        memcpy((void *)PORTING_CARTBANK0_ADR, gamedata, gamedata_size);
#endif
//        were_here("loaded %i bytes", gamedata_size);
//        if(gamedata_size == 0) {
//            // take built in rom
//            gamedata = game;
//            gamedata_size = game_size;        
//        }
        // init Handy
// memory doesn't seem to be free properly
//MEM_Init(LOW_MEM_START, LOW_MEM_SIZE);
//screenbuf = (unsigned short*)MEM_Malloc(160*102*2);
        newsystem = new CSystem(gamefile, romfile);
        newsystem->DisplaySetAttributes(MIKIE_NO_ROTATE, MIKIE_PIXEL_FORMAT_16BPP_555, 160*2, DisplayCallback, 0);
        frameskipcount = 0;
        frameskip = 3;
        frame = 0;
        sprites_enable = 1;
        // some in-Handy display
        clearText();
        slPrint("Rockin'-B's Lynx", slLocate(12, 3));
        slPrint("sprites_enable", slLocate(2, 26));
        slPrint("frameskip", slLocate(2, 27));
        slPrint("frame", slLocate(2, 28));
        while (1) {
            for (i=0;i<1024;i++) {
#if 0            
                data = Smpc_Peripheral[0].data;
                while((data & PER_DGT_ST) == 0) {
                    printDebug();
                    slSynch();
                    data = Smpc_Peripheral[0].data;
                } ;    
#endif
                newsystem->Update();
            }
            EMST_start(EMST_PAD);
            data = Smpc_Peripheral[0].data;
            if((data & PER_DGT_TZ) == 0)
                break;  // leave emu
            newsystem->SetButtonData(   ((data & PER_DGT_TA) == 0) ? BUTTON_A : 0 |
                                        ((data & PER_DGT_TB) == 0) ? BUTTON_B :0 |
                                        ((data & PER_DGT_TX) == 0) ? BUTTON_OPT1 :0 |
                                        ((data & PER_DGT_TY) == 0) ? BUTTON_OPT2 :0 |
                                        ((data & PER_DGT_ST) == 0) ? BUTTON_PAUSE :0 |
                                        ((data & PER_DGT_KU) == 0) ? BUTTON_UP :0 |
                                        ((data & PER_DGT_KD) == 0) ? BUTTON_DOWN :0 |
                                        ((data & PER_DGT_KL) == 0) ? BUTTON_LEFT :0 |
                                        ((data & PER_DGT_KR) == 0) ? BUTTON_RIGHT :0 );

            EMST_stop();
        }
        EMST_reset();
        delete newsystem;
        memset((void *)VDP2_VRAM_A0, CD_Black, 256*512*2);
        memset(screenbuf, 0, 160*102*2);
    }    
}



#if 1
#include <SGL.H>
/*********************************/
/* taken from cinit.c */
/*********************************/
#define		SystemWork		0x060ffc00		/* System Variable Address */
#define		SystemSize		(0x06100000-0x060ffc00)		/* System Variable Size */
/* sl.lnk Ŏw肵.bssZNV̊JnAIV{ */
extern Uint32 _bstart, _bend;
 
int main( void )
{
	Uint8	*dst;
	Uint32	i; 

	/* 1.Zero Set .bss Section */
	for( dst = (Uint8 *)&_bstart; dst < (Uint8 *)&_bend; dst++ ) {
		*dst = 0;
	}
	/* 2.ROM has data at end of text; copy it. */

	/* 3.SGL System Variable Clear */
	for( dst = (Uint8 *)SystemWork, i = 0;i < SystemSize; i++) {
		*dst = 0;
	}

	/* Application Call */
	ss_main();
	return 1;
}
#endif
