#include "portingHandy.h"
//#include <stdio.h>

unsigned char sprites_enable;

#ifdef PORTING_USE_OVERLOADING
#ifdef PORTING_USE_OVERLOADING_GLOBAL
// overloading new and delete operators
void *operator new(size_t size)
{
    void *ptr;
#ifdef PORTING_USE_LOW_RAM_GLOBAL    
    ptr = MEM_Malloc(size);
#else
    ptr = malloc(size);
#endif
#ifdef PORTING_DEBUG_OVERLOADING
    were_here("global new: %i bytes @ 0x%x", size, ptr);
#endif
    return ptr;
}

void operator delete(void *location)
{
#ifdef PORTING_DEBUG_OVERLOADING
    were_here("global delete");
#endif
#ifdef PORTING_USE_LOW_RAM_GLOBAL    
    MEM_Free(location);   
#else
    free(location);
#endif    
}

#endif // PORTING_USE_OVERLOADING_GLOBAL


void *operator new[](size_t size)
{
    void *ptr;
#ifdef PORTING_USE_LOW_RAM_GLOBAL    
    ptr = MEM_Malloc(size);
#else    
    ptr = malloc(size);
#endif
#ifdef PORTING_DEBUG_OVERLOADING
    were_here("global new[]: %i bytes @ 0x%x", size, ptr);
#endif
    return ptr;
}

void operator delete[] (void *location)
{
#ifdef PORTING_DEBUG_OVERLOADING
    were_here("global delete[]");
#endif
#ifdef PORTING_USE_LOW_RAM_GLOBAL    
    MEM_Free(location);   
#else
    free(location);    
#endif
}


#endif // PORTING_USE_OVERLOADING
