// !!!! take good care of the memory layout:
// not all dependencies are solved automatically
// you should better know what you do here...

#include "splitpath.h"
// debug
#include <RB_were_here.h>

#define EMST_DISABLE
#include <RB_EmuStats.h>
#define EMST_CPU    0
#define EMST_MICKIE 1
#define EMST_VRAM   2
#define EMST_PAD    3

#include <stdlib.h>

#ifdef __cplusplus
extern "C" {
#endif

#include <SEGA_MEM.H>

#ifdef __cplusplus
}
#endif

#define PORTING_SATURN
//#define PORTING_ROM_INCLUDED

// map my MSB flag
#ifdef PORTING_SATURN
#define MSB_FIRST
#endif

    // disables the throwing of CLynxException,
    // it's your turn if you set g++ flag -fno-exceptions
    // may hang..or not
#define PORTING_NO_EXCEPTION
    // the error interface comes by the cost of lots of 
    // memory for stream handling from stdc++.a
#define PORTING_NO_ERROR
//#define gError->Warning(m)
    // disables the loading of howard.o, if .lnx is headerless
#define PORTING_NO_HOWARD
    // disables the usage of ContextLoad in System creation
    // ---> why wasting code, if it is never used?
#define PORTING_NO_CONTEXT
    // we don't reference a game file by name on harddisc
    // Saturn CD access is different,
    // so we provide a memory file, instead
    // note: Cart.cpp copies the gamedata elsewhere
    //!!! this is inefficient!
#define PORTING_NO_GAMEFILE
    // location of provided game data in memory
#define PORTING_GAMEDATA_ADR    (UBYTE *)gamedata

// Handy copies the supplied rom to two banks
// or just one and uses the 2nd as shadow SRAM/EEPROM
//
// to avoid this memory overhead,
// we assign fixed positions.
// the roms default address is bank0
#define PORTING_CARTBANKS_FIXED

#ifdef PORTING_CARTBANKS_FIXED
#   define PORTING_CARTBANK0_ADR       ((unsigned char *)0x200000)
#   define PORTING_CARTBANK1_ADR       ((unsigned char *)0x200000 + 0x80000)
#endif

#define PORTING_NO_ROMFILE
    // location of provided rom data in memory
// unimplemented: #define PORTING_ROMDATA_ADR

/* Here you can define memory allocation
 * by parameterizing overloading of the operators
 * new, delete, <- can be switched(global or local ovrldng) for every single class
 * new[] and delete[] <- are set only globally
 */

//#define PORTING_USE_OVERLOADING 
//#define PORTING_USE_OVERLOADING_GLOBAL
//#define PORTING_USE_LOW_RAM_GLOBAL
#define PORTING_DEBUG_OVERLOADING

/* class by class settings */
#if (defined(PORTING_USE_OVERLOADING) && !defined(PORTING_USE_OVERLOADING_GLOBAL))

// new CSystem takes 262184 Bytes <-- because of lots of memory handlers
#define PORTING_USE_OVERLOADING_SYSTEM
//#define PORTING_USE_LOW_RAM_SYSTEM
//#define PORTING_USE_FIXED_ADDRESS_SYSTEM       0x0

// new CRam takes 65548 Bytes
#define PORTING_USE_OVERLOADING_RAM
//#define PORTING_USE_LOW_RAM_RAM
//#define PORTING_USE_FIXED_ADDRESS_RAM       0x0

// new CRom takes 1544 Bytes
#define PORTING_USE_OVERLOADING_ROM
//#define PORTING_USE_LOW_RAM_ROM
//#define PORTING_USE_FIXED_ADDRESS_ROM       0x0

// new CCart takes 132 Bytes
#define PORTING_USE_OVERLOADING_CART
//#define PORTING_USE_LOW_RAM_CART
//#define PORTING_USE_FIXED_ADDRESS_CART       0x0

// new CMickie takes 17324 Bytes
#define PORTING_USE_OVERLOADING_MICKIE
//#define PORTING_USE_LOW_RAM_MICKIE
//#define PORTING_USE_FIXED_ADDRESS_MICKIE      0x0

// new CSusie takes 260 Bytes
#define PORTING_USE_OVERLOADING_SUSIE
//#define PORTING_USE_LOW_RAM_SUSIE
//#define PORTING_USE_FIXED_ADDRESS_SUSIE       0x0

// new C65c02 takes 2116 Bytes
#define PORTING_USE_OVERLOADING_C65c02
//#define PORTING_USE_LOW_RAM_C65c02
//#define PORTING_USE_FIXED_ADDRESS_C65c02       0x0

// new CMemMap takes 24 Bytes
#define PORTING_USE_OVERLOADING_MEMMAP
//#define PORTING_USE_LOW_RAM_MEMMAP
//#define PORTING_USE_FIXED_ADDRESS_MEMMAP       0x0

#endif
// use upper part of low work RAM for allocation with certain new and new[] operators
#define LOW_MEM_USED        (0x80000 + 512)
#define LOW_MEM_START       (0x200000 + LOW_MEM_USED)
#define LOW_MEM_SIZE        (0x100000 - LOW_MEM_USED)

#ifdef PORTING_ROM_INCLUDED
extern char gamedata[];
#else
extern char *gamedata;
#endif
extern char romdata[];
extern int romdata_size;
extern int gamedata_size;
extern unsigned char sprites_enable;

#ifdef PORTING_USE_OVERLOADING
#   ifdef PORTING_USE_OVERLOADING_GLOBAL
void *operator new(size_t size);
void operator delete(void *location);
#   endif
void *operator new[](size_t size);
void operator delete[](void *location);
#endif

